from flask import Flask, render_template_string
from debug import DebugMonitor

debug = DebugMonitor()

app = Flask(__name__)


@app.route("/")
def home():
    return render_template_string("""
    <html>
        <head><title>Ruby Debug Dashboard</title></head>
        <body>
            <h1>🧠 Ruby Live Debug</h1>
            <p><b>Last Dream:</b> {{ debug.last_dream }}</p>
            <p><b>Last Thought:</b> {{ debug.last_thought }}</p>
            <p><b>Last Loss:</b> {{ debug.last_loss }}</p>
            <p><b>Last Reply:</b> {{ debug.last_context }}</p>
        </body>
    </html>
    """, debug=debug)

if __name__ == "__main__":
    app.run(port=5000)
